﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace MultiSDIApplication
{
    public partial class FormTopLevel : Form
    {
        static int formCount = 0;
        public FormTopLevel()
        {
            InitializeComponent();
            formCount++;
            this.Text = String.Format("{0}:{1}", this.Text, formCount);
            MultiSDIApplication.Application.AddTopLevelForm(this);
            MultiSDIApplication.Application.AddWindowMenu(windowToolStripMenuItem);
        }

        String FileName { get; set; }
            
        public static FormTopLevel CreateTopLevelWindow(String fileName)
        {
            if (!String.IsNullOrEmpty(fileName))
            {
                foreach (FormTopLevel form in Application.OpenForms)
                {
                    if (String.Compare(form.FileName, fileName, true) == 0)
                    {
                        form.Activate();
                        return form;
                    }
                }
            }

            FormTopLevel newForm = new FormTopLevel();
            newForm.OpenFile(fileName);
            newForm.Show();
            newForm.Activate();
            return newForm;
        }


        private void OpenFile(String fileName)
        {
            this.FileName = fileName;
            if (File.Exists(fileName))
            {
                using (StreamReader reader = new StreamReader(fileName))
                {
                    richTextBox.Text = reader.ReadToEnd();
                }
            }
            else
            {
                this.FileName = String.Format("Untitled {0}", formCount); 
            }
            this.Text = String.Format("{0} ({1})", this.Text, this.FileName);
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormTopLevel.CreateTopLevelWindow(null);
        }

    }
}
